 
#define KEY_DDR         DDRC
#define KEY_PORT        PORTC
#define KEY_PIN         PINC
#define KEY0            0
#define KEY1            1
#define KEY2            2
#define KEY3            3
#define KEY4            4
#define KEY5            5
#define KEY6            6
#define KEY7            7
//#define ALL_KEYS        (1<<KEY0 | 1<<KEY1 | 1<<KEY2)
#define ALL_KEYS        0xff

 
#define REPEAT_MASK      0 //(1<<KEY1 | 1<<KEY2)       // repeat: key1, key2
#define REPEAT_START    50                        // after 500ms
#define REPEAT_NEXT     20                        // every 200ms


#define SPALTENANZAHL 	   8 						//einfach 8, aber auch mehr be rmehr Ports oder Schieberegs
#define SPALTE_DDR         DDRA
#define SPALTE_PORT        PORTA
//#define SPALTE0            0						//kann man bei 8 oder mehr auch einfacher haben in dem man ALLE_SPALTEN fest definiert
//#define SPALTE1            1
//#define SPALTE2            2
#define ALLE_SPALTEN       0xff
 
#define ZEILE_DDR         DDRC						//Zeilen sollten bei max 8 bleiben, sonst LED's zu dunkel und 
#define ZEILE_PORT        PORTC						//Input >8bit schwieriger zu handhaben
#define ZEILE_PIN         PINC
//#define ZEILE0            0							//kann man bei 8 auch einfacher haben in dem man ALLE_ZEILEN fest definiert
//#define ZEILE1            1
//#define ZEILE2            2
//#define ALLE_ZEILEN        (1<<ZEILE0 | 1<<ZEILE1 | 1<<ZEILE2)
#define ALLE_ZEILEN			0xff

#define TEILER				4		//um vom 10ms Interrupt auf 2,5ms zu kommen

uint8_t get_key_press( uint8_t key_mask, uint8_t spalte );
void einschwingen(void);
void init_key_led(void);
void alle_blinken(bool on_off);


volatile uint8_t led_s[SPALTENANZAHL + 2];
volatile uint8_t led_mode[SPALTENANZAHL + 2];


volatile uint8_t key_state[SPALTENANZAHL];                                // debounced and inverted key state: bit = 1: key pressed
volatile uint8_t key_press[SPALTENANZAHL];                                // key press detect
volatile uint8_t key_rpt[SPALTENANZAHL];                                  // key long press and repeat


